.code

; decrypt_mangled_api, decrypt_asciiz_and_firstthunk & fix_orig_thunk routines


;_________________________________________________________________________________________
; everyone can steal code, but only a chosen few can understand

decrypt_mangled_api:

    mov     eax, dword ptr [memory_ptr]
    mov     edi, dword ptr [import_ptr]
    add     edi, eax

l0040151D:
    mov     ebx, dword ptr [edi]     ; edi points to image_import_descriptor
    or      ebx, dword ptr [edi+0Ch]
    jne     more_to_demangle
    ret

more_to_demangle:
    mov     esi, dword ptr [edi+0Ch]    ; pointer to library name
    sub     esi, dword ptr [rdata_va_offset]
    add     esi, eax
    cmp     dword ptr [esi], 'NREK' ; 'KERN'
    je      demangle_this_thunk
    cmp     dword ptr [esi], 'RESU' ; 'USER'
    je      demangle_this_thunk
    cmp     dword ptr [esi], 'nrek' ; 'kern'
    je      demangle_this_thunk
    cmp     dword ptr [esi], 'resu' ; 'user'
    je      demangle_this_thunk

demangle_next_iid:
    add     edi, 14h
    jmp     l0040151D


demangle_this_thunk:
    mov ebx, dword ptr [edi]
    sub ebx, dword ptr [rdata_va_offset]
    add ebx, eax
    mov dword ptr [de_thunk_ptr], ebx
    xor edx, edx

demangle_l1:
    inc edx
    cmp dword ptr [ebx+4*edx], 00000000     ; count api pointers
    jne demangle_l1
    mov dword ptr [api_counter], edx
    call l00401585
    call l004015F7
    jmp demangle_next_iid


l00401585:
    pushad
    xor ebp, ebp
    mov edx, 0ffffffffh
    mov esi, dword ptr [api_counter]
    mov eax, esi
    add eax, eax

demangle_l2:
    inc edx
    shr eax, 1
    jne demangle_l2     ; count BIT's ?? really weird..
    mov dword ptr [demangle_temp3], edx
    mov edi, [decrypt_key]
    mov ebx, offset demanglebuffer1
    xor eax, eax

demangle_l3:
    mov dword ptr [ebx+4*eax], eax
    inc eax
    cmp eax, esi
    jb demangle_l3

demangle_l4:
    imul edi, 35E85A6Dh
    add edi, 361962E9h
    mov edx, dword ptr [demangle_temp3]
    mov ecx, edx
    mov eax, edi
    shr eax, cl
    mov ecx, 20h
    sub ecx, edx
    imul eax, esi
    shr eax, cl
    mov ecx, ebp
    cmp eax, ecx
    je demangle_l5
    push dword ptr [ebx+4*ecx]
    mov edx, dword ptr [ebx+4*eax]
    mov dword ptr [ebx+4*ecx], edx
    pop dword ptr [ebx+4*eax]

demangle_l5:
    inc ebp
    cmp ebp, esi
    jb demangle_l4
    popad
    ret


l004015F7:
    pushad
    xor eax, eax
    mov esi, dword ptr [de_thunk_ptr]
    mov edi, offset demanglebuffer2
    mov ecx, dword ptr [api_counter]
    cld
    repz
    movsd
    mov esi, offset demanglebuffer1
    mov edi, dword ptr [de_thunk_ptr]

demangle_l6:
    xor ebp, ebp

demangle_l7:
    cmp eax, dword ptr [esi+4*ebp]
    je demangle_l8
    inc ebp
    jmp demangle_l7

demangle_l8:
    mov ecx, dword ptr [edi+4*ebp]
    mov dword ptr [4*eax+offset demanglebuffer2], ecx
    inc eax
    cmp eax, dword ptr [api_counter]
    jb demangle_l6
    mov esi, offset demanglebuffer2
    mov ecx, dword ptr [api_counter]
    repz movsd
    popad
    ret



;_________________________________________________________________________________________ 

decrypt_asciiz_and_firstthunk:
    pushad
    lea     ebp, api_pointers  
    mov     ebx, dword ptr [memory_ptr]
    mov     edx, dword ptr [import_ptr]
    add     edx, ebx
    sub     ebx, dword ptr [rdata_va_offset]

next_iid:
    mov     eax, dword ptr [edx]    ; yak yak yak, edx -> image_import_descriptors
    or      eax, dword ptr [edx+0Ch]
    jne     scan4k32_or_u32         ; jne were not on the NULL terminator of the iid's
    popad
    ret


scan4k32_or_u32:
    mov esi, dword ptr [edx+0Ch]    ; pointer to lib name
    add esi, ebx
    cmp dword ptr [esi], 'NREK'     ; 'KERN'
    je correct_iid
    cmp dword ptr [esi], 'RESU'     ; 'USER'
    je correct_iid
    cmp dword ptr [esi], 'nrek'     ; 'kern'
    je correct_iid
    cmp dword ptr [esi], 'resu'     ; 'user'
    jne try_next_iid
    
correct_iid:
    mov eax, [ebp]  ; load missing pointer into eax..
    add ebp, 4
    mov esi, dword ptr [edx]    ; ptr to original_first_thunk
    add esi, ebx                ; add fixed memptr to it
    mov ecx, dword ptr [esi]    ; ptr to asciiz
    or ecx, ecx                 ; fucked thunk arrays begin NULL terminated :D
    jne try_next_iid
    mov dword ptr [esi], eax    ; stamp missing key into NULL

next_asciiz_pointer:
    mov edi, dword ptr [esi]
    or edi, edi
    jne more_asciiz_2_decrypt

try_next_iid:
    add edx, 14h
    jmp next_iid

more_asciiz_2_decrypt:
    xor edi, [decrypt_key]      ; main decrypt key xor asciiz pointer
    mov dword ptr [esi], edi    ; stamp it back into thunk
    add esi, 4
    add edi, ebx                ; edi -> asciiz now
    mov word ptr [edi], 0       ; NULL the 'hint'
    add edi, 2
    mov cl, [asciiz_key]

decrypt_asciiz_loop:            ; decrypt the asciiz
    mov al, byte ptr [edi]
    mov ch, al
    xor al, cl
    mov byte ptr [edi], al
    je next_asciiz_pointer
    mov cl, ch
    inc edi
    jmp decrypt_asciiz_loop 

;_________________________________________________________________________________________ 

fix_orig_thunk: ; copy fixed first thunk, over original first thunk, thus, fixing it
    pushad
    xor     ebp, ebp
    xor     ecx, ecx
    mov     ebx, dword ptr [memory_ptr]
    mov     edx, dword ptr [import_ptr]
    add     edx, ebx
    sub     ebx, dword ptr [rdata_va_offset]

flt_scan4last_iid:
    mov     eax, dword ptr [edx]     ; edx points to image_import_descriptor
    or      eax, dword ptr [edx+0Ch] ; scan for the NULL terminating image_import_descriptor
    jne     flt_check_for_kORu       ; jump if not equal to fix_last_thunk_check_for_kernel_or_user
    popad
    ret

flt_check_for_kORu:
    mov     esi, dword ptr [edx+0Ch]    ; pointer to library name
    add     esi, ebx
    cmp     dword ptr [esi], 'NREK' ; KERN - EL
    je      flt_kernel_iid
    cmp     dword ptr [esi], 'nrek' ; kern - el
    je      flt_kernel_iid
    cmp     dword ptr [esi], 'RESU' ; USER
    je      flt_user_iid
    cmp     dword ptr [esi], 'resu' ; user
    jne     flt_next_iid

flt_user_iid:
    mov     esi, dword ptr [edx]        ; ptr to original first thunk
    add     esi, ebx
    mov     edi, dword ptr [edx+10h]    ; ptr to 'fixed' first thunk
    mov     [begin_user_thunk+ecx], edi ; data we require for 'fixing' code section
    add     edi, ebx

flt_copy_user_pointers:
    mov     eax, dword ptr [esi]
    mov     dword ptr [edi], eax    ; copy first thunk pointers into original first thunk
    add     esi, 4
    add     edi, 4
    or      eax, eax
    jne     flt_copy_user_pointers
    sub     edi, ebx
    sub     edi, 4
    mov     [end_user_thunk+ecx], edi   ; data we require for 'fixing' code section
    add     ecx, 04h
    add     edx, 14h
    jmp     flt_scan4last_iid

flt_kernel_iid:
    mov     esi, dword ptr [edx]        ; ptr to original first thunk
    add     esi, ebx
    mov     edi, dword ptr [edx+10h]    ; ptr to 'fixed' first thunk
    mov     [begin_kernel_thunk+ebp], edi   ; data we require for 'fixing' code section
    add     edi, ebx

flt_copy_kernel_pointers:
    mov     eax, dword ptr [esi]
    mov     dword ptr [edi], eax        ; copy first thunk pointers into original first thunk
    add     esi, 4
    add     edi, 4
    or      eax, eax
    jne     flt_copy_kernel_pointers
    sub     edi, ebx
    sub     edi, 4
    mov     [end_kernel_thunk+ebp], edi ; data we require for 'fixing' code section
    add     ebp, 04h

flt_next_iid: 
    add     edx, 14h                    ; point edx to next image_import_descriptor
    jmp     flt_scan4last_iid

;_________________________________________________________________________________________
